function [cv,cvstep] = CV( y, X,flag_warm_start, flag_ls, Ng)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
% y                 = response vector
% X                 = full dictionary
% flag_warm_start   = if 1, applies warm start; if 0 does not apply
% flag_ls           = LS estimation is performed
% Ng                = no. of points on the grid for Bbar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


n = length(y);
SEL = zeros(Ng,1); %square error loss
SEL_vec = zeros(Ng,25);
subset = zeros(n-1,25);



for i = 1:25
    subset(:,i) = datasample(1:n, n-1, 'Replace',false);

    
    [Matbeta, ~, ~, ~, ~] = cmp( y(subset(:,i),:), X(subset(:,i),:), flag_warm_start, flag_ls,  20000, 10^-6, 20);

    X_prime = X(setdiff((1:n), subset(:,i)),:);
    y_prime = y(setdiff((1:n), subset(:,i)),:);
    for j = 1:Ng
        SEL(j) = (y_prime - X_prime*Matbeta(:,j))^2;
    end
    SEL_vec(:,i) = SEL;
end
cv = mean(SEL_vec,2);
[~,cvstep] = min(cv); 
end



    
    
    
    
