function gen_table_NMSE(flag_warm_start, flag_ls)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
% flag_warm_start   = '0'  if 0, do not apply warm start 
% flag_ls           = '1'  LS estimation is performed 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/PAresults/FullSet/PA_NMISE_FullSet.mat');
load(fnamea);
comp_NMISE(:,1)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/PAresults/ConSet/PA_NMISE_ConSet.mat');
load(fnamea);
comp_NMISE(:,2)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/PEresults/FullSet/PE_NMISE_FullSet.mat');
load(fnamea);
comp_NMISE(:,3)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/PEresults/ConSet/PE_NMISE_ConSet.mat');
load(fnamea);
comp_NMISE(:,4)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/TAresults/FullSet/TA_NMISE_FullSet.mat');
load(fnamea);
comp_NMISE(:,5)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/TAresults/ConSet/TA_NMISE_ConSet.mat');
load(fnamea);
comp_NMISE(:,6)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/WHresults/FullSet/WH_NMISE_FullSet.mat');
load(fnamea);
comp_NMISE(:,7)= NMISE*100;
fnamea = strcat('./NIWAResultsCV_warm',flag_warm_start,'_ls', flag_ls, '/WHresults/ConSet/WH_NMISE_ConSet.mat');
load(fnamea);
comp_NMISE(:,8)= NMISE*100;


for ii = 1:size(comp_NMISE,1)
    for jj = 1: size(comp_NMISE,2)
        if comp_NMISE(ii,jj) >100
            comp_NMISE(ii,jj) = 100;
        end
    end
end


mi = zeros(size(comp_NMISE,2),1);
semi = zeros(size(comp_NMISE,2),1);
mm = zeros(size(comp_NMISE,2),1);

criteria = {'$aic_C$', '$kic$', '$kic_C$', '$bic$','$ebic$', '$ebic^o$',...
    '$sco$','$es$', '$gmdl$','$egm$', '$mmlu$', '$mmlg$', 'CV'};





fnameM = strcat('NMISECV_warm',flag_warm_start,'_ls', flag_ls, '.tex');
fid = fopen(fnameM, 'w');
fprintf(fid, '\\begin{tabular}[t!]{lcccccccc} \n');
fprintf(fid, '\\hline \n');
fprintf(fid, '& \\multicolumn{2}{c}{Patumahoe} & \\multicolumn{2}{c}{Penrose} & \\multicolumn{2}{c}{Takapuna} & \\multicolumn{2}{c}{Whangaparaoa} \\\\ \n');
fprintf(fid, '\\hline \n');
fprintf(fid, ' & FullSet & ConSet & FullSet & ConSet& FullSet & ConSet& FullSet & ConSet \\\\ \n');

for ii = 1:length(criteria)
    fprintf(fid, char(criteria(ii)));
    fprintf(fid, '&');


    for jj = 1:size(comp_NMISE,2)
           [mi(jj,1), ~] = min(comp_NMISE(:,jj));
           semi(jj,1) =  mi(jj,1) + 1/100*mi(jj,1);
           mm (jj,1) = mi(jj,1) + 10/100*mi(jj,1);
            if comp_NMISE(ii,jj) == mi(jj,1)
                fprintf(fid, '{\\underline{ \\bf  %4.2f }}', comp_NMISE(ii,jj));
            else
                if comp_NMISE(ii,jj) <= semi(jj,1)
                    fprintf(fid, '{ \\bf  %4.2f }', comp_NMISE(ii,jj));
                else
                    if comp_NMISE(ii,jj) >= mm(jj,1)
                    fprintf(fid, '{ \\it %4.2f }', comp_NMISE(ii,jj));
                    else
                        fprintf(fid, '%4.2f', comp_NMISE(ii,jj));   
                    end %% if bad results
                end %%if second minimum
            end %%if minimum
   
      
                
        if jj == size(comp_NMISE,2)
            fprintf(fid, '\\\\ \n');
        else
            fprintf(fid, '&');
        end  %if
    end %jj
end %ii

fclose(fid);


fid = fopen(fnameM,'a');
fprintf(fid, '\\hline \n');
fprintf(fid, '\\end{tabular} \n');
fclose(fid);
end
