function run_exp_ConSet(site)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Input:
%site = 'TA','PE', 'WH', 'PA'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=365;
denominator=0;
MSE_norm2_sum  = zeros(13,1);

%%%%%%%%%%%%%%%%
%%%Scenario 2%%%
%%%%%%%%%%%%%%%%

%Response:   
%Current PM2.5 from site4

%Predictors: 
%Current & past PM10  form site4,
%Current & past PM2.5 from all the other sites.

folder_name = strcat('./NIWAResults/', site,'results/ConSet');
[suc,~,~] = mkdir(folder_name);
if suc==0
    return;
end

%load data
fid = fopen('all_site.csv');
data = textscan(fid, '%s %f %f %s %f %f %s %f %f %s %f %f %s', 'Delimiter', ',', 'HeaderLines', 1);

fclose(fid);
allsite = [data(2) data(3) data(5) data(6) data(8) data(9) data(11) data(12)];
allsite = cell2mat(allsite);
% Column1: PM2.5 Patumahoe,    Col2: PM10 Patumahoe;
% Col3   : PM2.5 Penrose,      Col4: PM10 Penrose;
% Col5   : PM2.5 Takapuna,     Col6: PM10 Takapuna;
% Col7   : Pm2.5 Whangaparaoa, Col8: PM10 Whangaparoa.

%totally 2263 observations
%year14 = 1;     % 30/06/2014
year10 = 1460;  % 01/07/2010
%year08 = 2263;  % 19/04/2008
year08 = 2252; %30/04/2008 Control the total length as 100

%log transform all the data
log_allsites = log(allsite);



%length of the data from year 2008 to 2010
num = length(log_allsites(year10:year08,:));
startpoint = (1:8:num) + n * 4 - 1;
%from obs 1460 to 2252, which is from date 01/07/2010 to 30/04/2008

NTR = length(startpoint);

% four sites
if site     == 'PA'
    %res represents the response
    res     =  1;
    %v is the indicator of the predictors comes from which site.
    v     =  [2 3 5 7];
elseif site == 'PE'
    res     =  3;
    v     =  [4 1 5 7];
elseif site == 'TA'
    res     =  5;
    v     =  [6 1 3 7];
elseif site == 'WH'
    res     =  7;
    v     =  [8 1 3 5];
    
else       
    fprintf('ERROR: model\n');
    return;
end

for time = 1:NTR
    %build_0 = startpoint(time);        %from obs 1460 to 2252, which is from date 01/07/2010 to 30/04/2008
    %build_1 = startpoint(time) - n + 1;  %from obs 1096 to 1888, which is from date 31/06/2011 to 29/04/2009
    build_2 = startpoint(time) - 2*n + 1 ;  %from      731 to 1523,                    01/07/2012 to 29/04/2010
    build_3 = startpoint(time) - 3*n + 1; %from      366 to 1158,                    30/06/2013 to 29/04/2011
    %build_4 = startpoint(time) - 4*n + 1; %from        1 to  793,                    30/06/2014 to 29/04/2012
    
    % response y is the pm2.5 concentration of site4
    y  = log_allsites(build_2:(build_2+n - 1), res);  % PM2.5 viable with first entry selected from  01/07/2012 to 29/04/2010 with a length of 365
    %%01/07/2012--01/07/2011;29/04/2010--30/04/200930/06/2014 to 29/04/2012
    
    X  = zeros(n,68);     
    n = length(y);
    
    for i = 1:11
        %X(:,1:11) PM10 from site4
        X(:,i) = log_allsites((i + build_2-1) : (i + build_2 + n-1-1), v(1));
        %X(:,18:28) PM2.5 from site1
        X(:,i+17) = log_allsites((i + build_2-1) : (i + build_2 + n-1-1), v(2));
        %X(:,35:45) PM2.5 from site2
        X(:,i+34) = log_allsites((i + build_2-1) : (i + build_2 + n-1-1), v(3));
        %X(:, 52:62) PM2.5 from site3
        X(:,i+51) = log_allsites((i + build_2-1) : (i + build_2 + n-1-1), v(4));
    end
    
    for i = 12:14
        %X(:,12:14) PM10 from site4
        X(:,i) = log_allsites((i + build_2+172-1) : (i + build_2 + n-1+172-1), v(1));
        %X(:,29:31) PM2.5 from site1
        X(:,i+17) = log_allsites((i + build_2+172-1) : (i + build_2 + n-1+172-1), v(2));
        %X(:,46:48) PM2.5 from site2
        X(:,i+34) = log_allsites((i + build_2+172-1) : (i + build_2 + n-1+172-1), v(3));
        %X(:, 63:65) PM2.5 from site3
        X(:,i+51) = log_allsites((i + build_2+172-1) : (i + build_2 + n-1+172-1), v(4));
    end
    
    for i =15:17
        %X(:,15:17) PM10 from site4
        X(:,i) = log_allsites((i + build_2+350-1) : (i + build_2 + n-1+350-1), v(1));
        %X(:,32:34) PM2.5 from site1
        X(:,i+17) = log_allsites((i + build_2+350-1) : (i + build_2 + n-1+350-1), v(2));
        %X(:,49:51) PM2.5 from site2
        X(:,i+34) = log_allsites((i + build_2+350-1) : (i + build_2 + n-1+350-1), v(3));
        %X(:, 66:68) PM2.5 from site3
        X(:,i+51) = log_allsites((i + build_2+350-1) : (i + build_2 + n-1+350-1), v(4));
    end
    [Matbeta, vec_err, ITC, vec_combr] = omp( y, X);
    [cv,cvstep] = CV( y, X); 
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%prediction%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%   
    y_new = allsite(build_3:(build_3+n - 1), res); % PM2.5 variable from  30/06/2013 to 29/04/2011 with a length of 365
    X_new = zeros(n,68);
    
    
    for i = 1:11
        %X_new(:,1:11) PM10 from site4
        X_new(:,i) = log_allsites((i + build_3-1) : (i + build_3 + n-1-1), v(1));
        %X_new(:,18:28) PM2.5 from site1
        X_new(:,i+17) = log_allsites((i + build_3-1) : (i + build_3 + n-1-1), v(2));
        %X_new(:,35:45) PM2.5 from site2
        X_new(:,i+34) = log_allsites((i + build_3-1) : (i + build_3 + n-1-1), v(3));
        %X_new(:, 52:62) PM2.5 from site3
        X_new(:,i+51) = log_allsites((i + build_3-1) : (i + build_3 + n-1-1), v(4));
    end
    
    for i = 12:14
        %X_new(:,12:14) PM10 from site4
        X_new(:,i) = log_allsites((i + build_3+172-1) : (i + build_3 + n-1+172-1), v(1));
        %X_new(:,29:31) PM2.5 from site1
        X_new(:,i+17) = log_allsites((i + build_3+172-1) : (i + build_3 + n-1+172-1), v(2));
        %X_new(:,46:48) PM2.5 from site2
        X_new(:,i+34) = log_allsites((i + build_3+172-1) : (i + build_3 + n-1+172-1), v(3));
        %X_new(:, 63:65) PM2.5 from site3
        X_new(:,i+51) = log_allsites((i + build_3+172-1) : (i + build_3 + n-1+172-1), v(4));
    end
    
    for i =15:17
        %X(:,15:17) PM10 from site4
        X_new(:,i) = log_allsites((i + build_3+350-1) : (i + build_3 + n-1+350-1), v(1));
        %X(:,32:34) PM2.5 from site1
        X_new(:,i+17) = log_allsites((i + build_3+350-1) : (i + build_3 + n-1+350-1), v(2));
        %X(:,49:51) PM2.5 from site2 
        X_new(:,i+34) = log_allsites((i + build_3+350-1) : (i + build_3 + n-1+350-1), v(3));
        %X(:, 66:68) PM2.5 from site3
        X_new(:,i+51) = log_allsites((i + build_3+350-1) : (i + build_3 + n-1+350-1), v(4));
    end
    
    for jj=1:68
        X_new(:,jj) = X_new(:,jj) - mean ( X_new(:,jj) );
        X_new(:,jj) = sqrt(n)*( X_new(:,jj)/norm(X_new(:,jj)) );
    end
    
    
    meany_new   = mean(log_allsites(build_2:(build_2+2*n - 1), res));
    
    %ITC
    for ind = 1: size(ITC,1)
        [~,w] = min(ITC(ind,:));
        betahat = Matbeta(:,w);
        err2_mean = y_new - exp(X_new*betahat + meany_new); 
        MSE_norm2_sum(ind) = MSE_norm2_sum(ind) + sum(err2_mean.^2);
    end
    
    
    %CV
    cvbetahat = Matbeta(:,cvstep);
    err_out2_mean = y_new - exp(X_new*cvbetahat + meany_new); 
    MSE_norm2_sum(13) = MSE_norm2_sum(13) + sum(err_out2_mean.^2 );
   
    fname = strcat('./NIWAResults/', site,'results/ConSet','/Time_', num2str(time), '.mat');
    save(fname, 'Matbeta', 'ITC', 'cv', 'cvstep', 'vec_err', 'vec_combr');

    
    denominator = denominator + sum(y_new.^2);
end %for NTR


NMISE   = MSE_norm2_sum/denominator;
fnamea = strcat('./NIWAResults/', site,'results/ConSet/',site,'_NMISE_ConSet.mat');
save(fnamea, 'NMISE');

end
