function gen_combined_table(s)


labels = {
        'London'
        'East Midlands'                        
        'South West'                             
        'West Midlands Region' 
        'Yorkshire and The Humber'
        };
    
n = 12;             %no. of measurements/year    
nstep = 24;         %no. of months after which the model is adapted  
start =n+1;
stop = 613-(n+nstep-1);

regions = {'Region 1', 'Region 2', 'Region 3', 'Region 4', 'Region 5'};
algo = {'MPA', 'OMP', 'RMP', 'FWA', 'CMP'};
scenarios = {'I','II','III'};


err_mat = zeros(length(regions)+1,length(algo)+2);
itc_mat = strings(size(err_mat));
itc_mat(1:5,1) = algo;
scenarios_mat = strings(size(err_mat));
for ind_algo = 1:length(algo)
    
    algo_names = algo{ind_algo};
    if strcmp(algo_names,'MPA')||strcmp(algo_names,'RMP')
    ITC = {'$aic_C$', '$kic$', '$kic_C$', '$bic$','$ebic$', '$ebicd$', '$ebicg$',...
        '$sco_1$', '$sco_2$', '$es_1$', '$es_2$', '$es_1^*$', '$es_2^*$',...
        '$gmdl_1$','$gmdl_2$', '$egm_1$', '$egm_2$', '$egm_1^*$', '$egm_2^*$',...
        '$mmlu$', '$mmlg_1$', '$mmlg_2$','CV'};     
    elseif strcmp(algo_names,'OMP')||strcmp(algo_names,'CMP')||strcmp(algo_names,'FWA')
        ITC = {'$aic_C$', '$kic$', '$kic_C$', '$bic$','$ebic$', '$ebicg$',...
            '$sco$','$es$', '$gmdl$','$egm$', '$mmlu$', '$mmlg$', 'CV'};   
    else
        fprintf('Incorrect greedy algorithm');
        return;
    end
    
    
    for indl=1:length(labels)
    
    load('HPI');          % use HPI
    data = HPI;
    pos = [3 1 6 9 10];

    if nstep>=24
        vec_s = [1 2 12 nstep];
    else
        return;
    end
    
    label_reg = labels{indl};
    fname = strcat(algo_names,'_',label_reg,'_PredErrors.mat');
    load(fname);
    
    norm_sum = sum( data(start:stop,pos(indl)).^2 );
    
    err_min = Inf;
            for r=1:3
                for ind_itc = 1:size(ERRORS,2)
                    err = sum( squeeze(ERRORS(r,ind_itc,s,:)).^2 );
                    err = 100*err/norm_sum;
                    if err<err_min
                        err_min = err;
                        r_min = r;
                        itc_min = ind_itc;
                    end %if
                end %ind_itc
            end%r 
            
            err_mat(ind_algo,indl+1) = err_min;
            itc_mat(ind_algo,indl+1) = ITC(itc_min);
            scenarios_mat(ind_algo,indl+1) = scenarios(r_min);
            
    end%indl
end%ind_algo

err_mat(:,1) = Inf;
[~, ~, row_effect, column_effect,~] = median_polish(err_mat(1:length(algo),2:length(regions)+1), 0.01);
err_mat(1:length(algo),(length(labels)+2)) = column_effect;
err_mat((length(algo)+1),2:(length(labels)+1)) = row_effect;


fnameM = strcat('prediction_table_s1.tex');
fid = fopen(fnameM, 'w');
fprintf(fid, '\\begin{tabular}[t!]{lcccccc} \n');
fprintf(fid, '\\hline \n');
fprintf(fid, 'Algorithms & Region 1 & Region 2 & Region 3 & Region 4 & Region 5 & Effects  \\\\ \n');
fprintf(fid, '\\hline \n'); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for ind_algo = 1: length(algo)
    for ii = 1:3
        for jj = 1:size(err_mat,2)
                    
            if ii ==1
                fprintf(fid, ' %5.4f ', err_mat(ind_algo,jj));
                
            elseif ii==2                

                fprintf(fid, '%8s', char(itc_mat(ind_algo,jj)));
                
            elseif ii==3
                fprintf(fid, ' %5s ', char(scenarios_mat(ind_algo,jj)));
                
            end%if
                
            if jj == size(err_mat,2)
                fprintf(fid, '\\\\ \n');
            else
                fprintf(fid, '&');              
            end%if            
        end%for jj
    end%for ii
    fprintf(fid, '\\hline \n');
end%for_alao

fprintf(fid, 'Regions effects');
fprintf(fid, '\t &');
for rr = 1:length(row_effect)
    fprintf(fid, ' %5.4f ', row_effect(rr));
    fprintf(fid, '\t &');
end
fprintf(fid, '\\\\ \n');
fprintf(fid, '\\hline \n');
fprintf(fid, '\\end{tabular} \n');
fclose(fid);

end

            
                
   


