function gen_tables(algo)
labels = {
        'London'
        'East Midlands'                        
        'South West'                             
        'West Midlands Region' 
        'Yorkshire and The Humber'
        };
    
n = 12;             %no. of measurements/year    
nstep = 24;         %no. of months after which the model is adapted  
start =n+1;
stop = 613-(n+nstep-1);

regions = {'Region4$_1$', 'Region$_2$', 'Region$_3$', 'Region$_4$', 'Region$_5$'};

%regions = repelem([{'Region 1'}, {'Region 2'}, {'Region 3'}, {'Region 4'}, {'Region 5'}], [4 4 4 4 4])';
%n_prime = repmat([1; 2; 12; 24],5,1);
scenarios = {'I','II','III'};

if strcmp(algo,'MPA')||strcmp(algo,'RMP')
    ITC = {'$aic_C$', '$kic$', '$kic_C$', '$bic$','$ebic$', '$ebicd$', '$ebicg$',...
        '$sco_1$', '$sco_2$', '$es_1$', '$es_2$', '$es_1^*$', '$es_2^*$',...
        '$gmdl_1$','$gmdl_2$', '$egm_1$', '$egm_2$', '$egm_1^*$', '$egm_2^*$',...
        '$mmlu$', '$mmlg_1$', '$mmlg_2$','CV'};     
    elseif strcmp(algo,'OMP')||strcmp(algo,'CMP')||strcmp(algo,'FWA')
        ITC = {'$aic_C$', '$kic$', '$kic_C$', '$bic$','$ebic$', '$ebicg$',...
            '$sco$','$es$', '$gmdl$','$egm$', '$mmlu$', '$mmlg$', 'CV'};   
    else
        fprintf('Incorrect greedy algorithm');
        return;
end

fnameM = strcat(algo,'_err.tex');
fid = fopen(fnameM, 'w');
fprintf(fid, '\\begin{tabular}[t!]{lllll} \n');
fprintf(fid, '\\hline \n');
fprintf(fid, 'Region & $n^prime$ & Scenario & ITC & NMSE \\\\ \n');
fprintf(fid, '\\hline \n');  

for indl=1:length(labels)
    
    load('HPI');          % use HPI
    data = HPI;
    pos = [3 1 6 9 10];

    if nstep>=24
        vec_s = [1 2 12 nstep];
    else
        return;
    end
    
    label_reg = labels{indl};
    fname = strcat(algo,'_',label_reg,'_PredErrors.mat');
    load(fname);
    
    norm_sum = sum( data(start:stop,pos(indl)).^2 );
    

        for ind_s = 1:length(vec_s)
            if ind_s == 1
                fprintf(fid, char(regions(indl)));
            else 
                fprintf(fid,'%8s', '      ');
            end
            fprintf(fid, '\t &');
            fprintf(fid, '%2i', vec_s(ind_s));
            fprintf(fid, '\t &');
            s = vec_s(ind_s);
            
            err_min = Inf;
            for r=1:3
                for ind_itc = 1:size(ERRORS,2)
                    err = sum( squeeze(ERRORS(r,ind_itc,s,:)).^2 );
                    err = 100*err/norm_sum;
                    if err<err_min
                        err_min = err;
                        r_min = r;
                        itc_min = ind_itc;
                    end %if
                end %ind_itc
            end%r
           
            fprintf(fid, '%5s', char(scenarios(r_min)));
            fprintf(fid, '\t & \t');
            fprintf(fid, '%8s', char(ITC(itc_min)));
            fprintf(fid, '\t &');
            fprintf(fid, '%5.4f', err_min);
            fprintf(fid, '\\\\ \n');
        end%ind_s
   
end % for indl
fid = fopen(fnameM,'a');
fprintf(fid, '\\hline \n');
fprintf(fid, '\\end{tabular} \n');
fclose(fid);
end
