function run_exp_data_uk(algo)
    fprintf(algo);
    fprintf('\n');
labels = {
        'London'
        'East Midlands'                        
        'South West'                             
        'West Midlands Region' 
        'Yorkshire and The Humber'
        };

n = 12;             %no. of measurements/year    
nstep = 24;         %no. of months after which the model is adapted
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for indl=1:length(labels)
    label_reg = labels{indl};
    for flag_others=0:2
        [start,stop] = exp_data_uk(labels, label_reg, flag_others, n, nstep, algo);
    end
    comp_stats(labels, indl, nstep, start, stop, algo);

    fname = strcat(algo,'_',label_reg,'_PredErrors.mat');
    load(fname);
    figure(indl);
    
    for s=1:2
        subplot(1,min(nstep,3),s);
        plot(start:stop,squeeze(ERRORS(1,6,s,:)),'k', ...
            start:stop,squeeze(ERRORS(2,6,s,:)),'b', ...
            start:stop,squeeze(ERRORS(3,6,s,:)),'r');
       % squeeze(ERRORS(3,6,s,1:3))
       % pause
        tit = sprintf('s=%i',s);
        tit = strcat(label_reg,'(',tit,')');
        title(tit);
        legend('Same Reg.','Other Reg.','All Reg.');
    end
    if nstep>2
        subplot(1,min(nstep,3),3);
        plot(start:stop,squeeze(ERRORS(1,6,nstep,:)),'k', ...
            start:stop,squeeze(ERRORS(2,6,nstep,:)),'b', ...
            start:stop,squeeze(ERRORS(3,6,nstep,:)),'r');
        tit = sprintf('s=%i',nstep);
        tit = strcat(label_reg,'(',tit,')');
        title(tit);
        legend('Same Reg.','Other Reg.','All Reg.');
    end
    % pause
    % fprintf('Press a key!\n');
end %indl
end %function

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function comp_stats(labels, indl, nstep, start, stop, algo)

load('HPI');          % use HPI
data = HPI;
positions = [3 1 6 9 10];

if nstep>=24
    vec_s = [1 2 12 nstep];
else
    return;
end
    

    label_reg = labels{indl};
    fname = strcat(algo,'_',label_reg,'_PredErrors.mat');
    load(fname);
    
    norm_sum = sum( data(start:stop,positions(indl)).^2 );

    for ind_s=1:length(vec_s)
        s = vec_s(ind_s);

        err_min = Inf;
        for r=1:3
            for ind_itc=1:size(ERRORS,2)
                err = sum( squeeze(ERRORS(r,ind_itc,s,:)).^2 );
                err = 100*err/norm_sum;
                % pause
                if err<err_min
                    err_min = err;
                    r_min = r;
                    itc_min = ind_itc;
                end %if
            end %ind_itc
        end %r
        fprintf('%30s \t s=%2i \t r_min=%i \t ind_itc=%2i \t %5.4f\n',label_reg,s,r_min,itc_min,err_min);
    end %ins_s


end %function

