function X = genX(n,p,T,theta,omega)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Input:
% n     = sample size (20,100,10000)
% p     = number of predictors (100)
% T     = depends on different Case (0, 100+n, 1000+n)
% theta = a parameter depends on Case
% omega = coefficients of AR model (0, 0.75)

%Output:
% X = dictionary n*p
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%generate \veps_{i,k} for k>0
if omega==0
    eps = randn(n+T,p);
elseif omega==0.75
    eps = filter(1,[1 -omega],sqrt(1-omega^2)*randn(100 + p, n+T));
    eps = eps(end-p+1:end,:);
    eps = eps';
    %the size of eps is (n+T,p) now. 
else
     fprintf('ERROR: omega\n');
     return;
end

%generate X
if T==0
    X = eps(end-n+1:end,:);
else
    X = filter(theta,1,eps);
    X = X(T+1:end,:);
end
    
end %function

