function run_exp_varx

NR          = 1;                                 %no. of runs
ALGO        = {'OMP', 'FWA', 'CMP'};             %algorithms
ITC_lab     =  {'AIC$_C$', 'KIC', 'KIC$_C$', 'BIC', 'EBIC', 'EBIC$^\circ$', 'SC', 'ESC', ...
    'gMDL', 'EgMDL', 'MMLU', 'MMLG'};
NoITC       = length(ITC_lab);                   %total no. ITC
vec_ct      = [1 1/10 1/100];                    %vector values ct
init        = 100;                               %no. of samples initialization
vec_len     = [50 100 200];                      %vector length blocks
distb       = 100;                               %dist. between consecutive blocks
vec_Th      = (0.5:0.1:0.9);                     %vector thresholds

array_beta_true = Inf*ones(NR, ...
    length(vec_ct), ...
    100);

mat_spec_rad = Inf*ones(NR,length(vec_ct));

TP = Inf*ones(NR, ... 
    length(vec_ct), ...
    length(ALGO), ...
    length(vec_len), ...
    length(vec_Th), ...
    NoITC);
FP = TP;

tic
for nr=1:NR
     fprintf('.');
     if mod(nr,10)==0
         fprintf('\n');
     end
    
    for ind_ct = 1:length(vec_ct)
        
        [Y, X0, beta_true, mat_spec_rad(nr,ind_ct), pmax, s] = gendata(vec_ct(ind_ct), init); %generate data
        array_beta_true(nr,ind_ct,:) = beta_true;
        
        for ind_algo=1:length(ALGO)
            
            for ind_len=1:length(vec_len)
                
                [TotalSelP, count] = run_algo(Y, X0, char(ALGO{ind_algo}), init, vec_len(ind_len), distb, pmax, s, NoITC);
                
                for ind_Th=1:length(vec_Th)
                
                    [TP(nr, ind_ct, ind_algo, ind_len, ind_Th, :), ...
                        FP(nr, ind_ct, ind_algo, ind_len, ind_Th, :)] ...
                        = comp_rates(TotalSelP, count, vec_Th(ind_Th), beta_true);
                   
                    
                end %ind_Th
                
                save('All_results_dummy.mat','TP','FP','array_beta_true','mat_spec_rad');
            
            end %ind_len
            
        end %ind_algo
        
        
    end %ind_ct
    
    
end %nr
fprintf('\n');
toc
    